
Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; ------ zobrazen vodnho textu

Start:   mov       dx,offset UvTxt
         mov       ah,9
         int       21h                      ; zobrazen vodnho textu

; ------ pprava k rozboru pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld

; ------ nalezen zatku jmna souboru

Start1:  jcxz      Start12                  ; nen nic zadno
         mov       dx,si                    ; zatek jmna souboru
         lodsb                              ; naten znaku
         dec       cx                       ; snen tae znak
         cmp       al," "
         je        Start1                   ; oddlovac mezera
         cmp       al,9
         je        Start1
         cmp       al,"?"
         je        Start12
         cmp       al,"*"
         je        Start12
         cmp       al,"/"
         jne       Start2
Start12: mov       dx,offset HelpTxt        ; npovda
         jmp       short Chyba              ; parametr

; ------ nalezen konce jmna souboru

Start2:  mov       di,si                    ; konec jmna souboru
         jcxz      Start3
         lodsb
         dec       cx
         cmp       al," "
         ja        Start2

; ------ koncov teka

Start3:  dec       di
         dec       di
         dec       di
         mov       al,"."
         cmp       byte ptr ds:[di-1],al
         je        Start4
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start4
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start4
         inc       di
         cmp       byte ptr ds:[di-1],al
         je        Start4
         stosb

; ------ oteven datovho souboru DBF

Start4:  mov       word ptr ds:[di],"BD"    ; ppona DBF
         mov       word ptr ds:[di+2],"F"
         mov       ax,3d00h
         int       21h                      ; oteven pro ten
         mov       ds:[SoubDbf],ax          ; datov soubor
         jnc       Start5                   ; soubor oteven OK

; ------ zobrazen npovdy

         mov       dx,offset NeniTxt        ; text - nenalezen
Chyba:   mov       ah,9
         int       21h
         int       20h

; ------ test, zda vstupn soubor DAT ji existuje

Start5:  mov       word ptr ds:[di],"AD"
         mov       word ptr ds:[di+2],"T"
         xor       cx,cx                    ; atributy
         mov       ah,4eh
         int       21h                      ; nalezen vstupnho souboru
         jc        Start6
         mov       dx,offset ExistTxt
         jmp       short Chyba

; ------ oteven vstupnho souboru

Start6:  mov       ah,3ch
         xor       cx,cx
         int       21h                      ; vytvoen vstupnho souboru
Start62: mov       dx,offset WritTxt        ; chyba zpisu
         jc        Chyba                    ; chyba vytvoen souboru
         mov       ds:[SoubDat],ax          ; vstupn soubor

; ------ naten zhlav souboru

         mov       dx,offset HeadDBF
         mov       cx,32                    ; dlka zhlav
         mov       ah,3fh
         mov       bx,ds:[SoubDBF]
         int       21h                      ; naten zhlav
         jc        Start62
         cmp       ax,cx
         jne       Start62

; ------ kontrola, zda se zhlav vejde do pamti

         mov       ax,ds:[HeadByte]
         add       ax,dx
         add       ax,200h
         cmp       ax,sp
         mov       dx,offset MemTxt
         jae       Start62                  ; nedostatek pamti

; ------ naten zhlav do pamti

         mov       cx,ds:[HeadByte]
         sub       cx,32
         mov       dx,offset TabPopis
         mov       ah,3fh
         int       21h                      ; naten definice poloek
         jc        Start62
         cmp       ax,cx
         jne       Start62
         add       ds:[AdrBuff],cx          ; adresa k naten zznamu

; ------ kontrola, zda se 1 zznam vejde do pamti

         mov       ax,ds:[AdrBuff]          ; adresa bufferu zznamu
         add       ax,ds:[ZaznByte]
         add       ax,200h
         cmp       ax,sp
         jae       Start62                  ; nedostatek pamti

; ------ naten jednoho zznamu

Start8:  mov       dx,ds:[AdrBuff]
         mov       cx,ds:[ZaznByte]
         mov       ah,3fh
         mov       bx,ds:[SoubDbf]
         int       21h                      ; naten zznamu
         jc        Start98
         cmp       ax,cx
         jne       Start98

; ------ korekce dku

         dec       cx                       ; bez vodnho bajtu
         inc       dx
         mov       si,dx
         mov       di,si
         cld
Start82: lodsb
         cmp       al," "
         jne       Start85
         cmp       byte ptr ds:[si]," "
         jne       Start85
         mov       al,9
         stosb
         dec       cx
         jz        Start86
Start83: lodsb
         cmp       al," "
         jne       Start85
         loop      Start83
         jmp       short Start86

Start85: stosb
         loop      Start82

Start86: cmp       byte ptr ds:[di-1],9
         jne       Start87
         dec       di
Start87: ;mov       al,13
         ;stosb
         mov       al,10
         stosb

; ------ zpis dku

         sub       di,dx
         mov       cx,di
         mov       bx,ds:[SoubDat]
         mov       ah,40h
         int       21h
         jnc       Start8

; ------ uzaven soubor

Start98: mov       bx,ds:[SoubDbf]
         mov       ah,3eh
         int       21h
         mov       bx,ds:[SoubDat]
         mov       ah,3eh
         int       21h
         int       20h

; -----------------------------------------------------------------------------
;        Data
; -----------------------------------------------------------------------------
;
SoubDbf  dw        0                        ; identifiktor vstupnho souboru
SoubDat  dw        0                        ; identifiktor vstupnho souboru

UvTxt    db        'SEZNDAT V1.0 - konverze DBF na seznam; (c) Miroslav Nemecek',13,10,'$'

NeniTxt  db        'Zadany vstupni soubor DBF nenalezen !',13,10
HelpTxt  db        '  Zadejte JMENO souboru DBF ke konverzi do seznamu.',13,10
         db        '  Bude zkonvertovan soubor JMENO.DBF na JMENO.DAT.',13,10,'$'

ExistTxt db        'Vystupni soubor DAT jiz existuje !',13,10,'$'
MemTxt   db        'Nedostatek pameti k provedeni konverze !',13,10,'$'
WritTxt  db        'Chyba zapisu do vystupniho souboru DAT !',13,10,'$'

Nadpis   db        300 dup(" ")             ; nadpis
Maska    db        300 dup("#")             ; maska

AdrBuff  dw        offset TabPopis

; ------ zhlav souboru DBF

HeadDBF  label     byte
Verze    db        3                        ; 0: verze databze
Rok      db        0                        ; 1: rok
Mesic    db        1                        ; 2: msc
Den      db        1                        ; 3: den
PocVet   dd        0                        ; 4: poet vt
HeadByte dw        33                       ; 8: velikost zhlav (bajt)
ZaznByte dw        1                        ; 0Ah: dlka zznamu (bajt)
         db        20 dup(0)                ; 0Ch:  ... rezervovno
TabPopis label     byte                     ; 20h: tabulka popisova

; Popisova (kad 32 bajt, za poslednm popisovaem je 0Dh):
;             0 (11) jmno poloky ASCIIZ (s 0 na konci)
;            11 (1) typ poloky (C, N, F, L, D nebo M)
;                          typ C (Character): text doplnn zprava mezerami
;                                             dlka max. 254 znak
;                          typ N (Numeric): slo s pevnou desetinnou tekou,
;                                           znaky "0" a "9","-", "+" a "."
;                                           max. 20 pozic (max. 15 des. mst)
;                          typ F (Float): reln slo s pohyblivou tekou,
;                                           max. 20 pozic (max. 15 des. mst),
;                                           rozsah 0.9xE+308 a 0.1xE-307,
;                                           max. 15 slic ped tekou a 9 za
;                          typ L (Logical): hodnoty Y,y,N,n,T,t,F,f,mezera
;                          typ D (Date): osum slic RRRRMMDD
;                          typ M (Memo): deset slic - slo potenho bloku
;                                        .DBT textu k poloce
;                          typ P (Picture): (pouze FOXPRO)
;            12 (4) adresa obsahu poloky v pamti
;            16 (1) dlka poloky v zznamu (bajt)
;            17 (1) poet desetinnch mst
;            18 (2) ... rezervovno
;            20 (1) oznaen pracovn oblasti
;            21 (2) ... rezervovno
;            23 (1) nvt pro SET FIELDS TO (...)
;            24 (8) ... rezervovno
;
; zznam:     0 (1) pznak zruen poloky - "*"=zruen, jinak " "
;             1 (x) poloky (nsleduj bezprostedn za sebou)

Code     ENDS
         END       Start
